-- sqlite3

CREATE TABLE IF NOT EXISTS groups(
    id BIGINT PRIMARY KEY,
    group_id BLOB NOT NULL,
    slug TEXT NOT NULL,
    created_at DATETIME NOT NULL
);

CREATE UNIQUE INDEX IF NOT EXISTS idx_groups_group_id ON groups(group_id);

CREATE TABLE IF NOT EXISTS tags(
    id BIGINT PRIMARY KEY,
    value TEXT NOT NULL,
    created_at DATETIME NOT NULL
);

CREATE UNIQUE INDEX IF NOT EXISTS idx_tags_value ON tags(value);

CREATE TABLE IF NOT EXISTS tickets(
    id BIGINT PRIMARY KEY,
    ticket_number INTEGER NOT NULL,
    group_id BLOB NOT NULL,
    created_at DATETIME NOT NULL,
    title TEXT NOT NULL,
    description TEXT NOT NULL,
    status TEXT NOT NULL
);

CREATE UNIQUE INDEX IF NOT EXISTS idx_tickets_number_group
ON tickets(group_id, ticket_number);

CREATE TABLE IF NOT EXISTS ticket_tags(
    id BIGINT PRIMARY KEY,
    ticket_id BIGINT NOT NULL,
    tag_id BIGINT NOT NULL
);

CREATE UNIQUE INDEX IF NOT EXISTS idx_ticket_tags_ticket_tag
ON ticket_tags(ticket_id, tag_id);

CREATE TABLE IF NOT EXISTS ticket_history(
    id BIGINT PRIMARY KEY,
    ticket_id BIGINT NOT NULL,
    status TEXT NOT NULL,
    set_at DATETIME NOT NULL
);

CREATE INDEX IF NOT EXISTS idx_ticket_history_order_ticket_set_at
ON ticket_history(ticket_id, set_at);
